;Coded 1996.5.1,  revised 2023.8.15
;---------------------}N----------
print		macro   N
        	mov     dx,offset msg_&N
        	call    puts09
        	endm
;--------------------------------------
	.186
;	풓foCXhCo`
code		segment
		assume	cs:code

		ORG	0h
start:
header: 	JMP     COM_init
		nop
dev_attr	DW	8000h
		DW	strategy	;Device Strategy Entry Pointer
		DW	dev_int		;Device Interupt Entry Pointer
dev_name	DB	'$WBC486$'
		DB	8 dup(0)

packet		DD	?		;command packet address

dev_routine	PROC	FAR
strategy:
		mov	word ptr cs:[packet    ],bx
		mov	word ptr cs:[packet + 2],es
		ret
dev_int:
		pusha
		push	ds
		push	es

		lds	di,cs:[packet]
		cmp	byte ptr [di + 2],00h
		jz	dev_init
		mov	word ptr [di + 3],8103h	;command error status
dev_int_ret:
		pop	es
		pop	ds
		popa
		ret
dev_routine	ENDP

dev_init:
		cld
		mov	ax,cs
		mov	ds,ax

		lds	si,cs:[packet]
		lds	si,ds:[si + 18]

;s---------------
		print	TTL
		mov	dx,063Fh
		in	al,dx
		cmp	al,0FFh
		je	WringMachine

		mov	dx,063Fh
		in	al,dx
		or	al,10000000b
		out	dx,al
		mov	dx,043Fh
		mov	al,0A0h
		out	dx,al
		jmp	end_job
WringMachine:
		print   BAD
end_job:
;sI
		push	cs
		pop	es	;ES=CS

		push	cs      ;DS=CS
		pop	ds
		jnc	NotRegident
		;
NotRegident:
		mov	word ptr cs:[header    ],0FFFFh
		mov	word ptr cs:[header + 2],0FFFFh
		mov	word ptr cs:[dev_attr],0
		lds	di,cs:[packet]
		mov	byte ptr [di + 13],0	;	unit 
		mov	word ptr [di + 14],offset header
		mov	word ptr [di + 16],cs
		mov	word ptr [di + 3],0100h	;	status
		jmp	dev_int_ret

        	org     0100h
COM_init:
		mov     ax,data
		mov     ds,ax
        	print   TTL
		mov     dx,063Fh
		in      al,dx
		cmp     al,0FFh
		jne     WBOK
		print   BAD
		print   MAC
		jmp     ExitDOS
WBOK:   
		mov     ax,es
		mov     ds,ax
		mov     di,1000H
        
ext_1:		mov     si,80H
		lodsb
		xor     ah,ah
		mov     cx,ax
		jcxz    NoChange
        
ext_2:		lodsb
		cmp     al,'0'
		ja      ext_3
		loop    ext_2
		jmp     NoChange
USA_DISP:
		print   USA
		jmp     ExitDOS
        
ext_3:		dec     si
		lodsw
		or      ax,2020H
		cmp     ax,'no'
		je      AnableWB
NoChange:
		cmp	ax,'fo'
		je	DisabledWB
		cmp	al,'?'
		je	USA_DISP
		print	STAT
		mov	dx,063Fh
		in	al,dx
		test	al,10000000b
		jz	NowOff
		print	ON
		jmp	NowBi
NowOff:		print	OFF
NowBi:		print	IS
		JMP     ExitDOS
AnableWB:
		mov     dx,043Fh
		mov     al,0A0h
		out     dx,al
		mov     dx,063Fh
		in      al,dx
		mov     ah,10000000b
		or      al,ah
		out     dx,al
		mov     dx,043Fh
		mov     al,0A0h
		out     dx,al
		print   SUBJ
		print   ON
		print   DONE
		jmp     ExitDOS
DisabledWB:
		mov	dx,043Fh
		mov	al,0A0h
		out	dx,al
		mov	dx,063Fh
		in	al,dx
		mov	ah,01111111b
		and	al,ah
		out	dx,al
		print	SUBJ
		print	OFF
		print	DONE
		mov	dx,043Fh
		mov	al,0A0h
		out	dx,al
		JMP	ExitDOS

ExitDOS:        mov     ah,4Ch
                int 21h
                RET

puts09		PROC   near
		push	ds
		push	ax
		push	dx
		mov	ax,data
		mov	ds,ax
		mov	ah,9
		int  21h
		pop	dx
		pop	ax
		pop	ds
		ret
puts09		ENDP

code		ends

data		segment
		assume	ds:data

CR      equ     13
LF      equ     10
BELL    equ     7
EOF     equ     '$'

msg_TTL DB  CR,LF,"Enable/Disable write back cachemWB.EXEn V1.40  Copyright (C)1996,2023 ܂ ",CR,LF,EOF
msg_BAD DB  "̋@ł͎gpłȂ, gpӖ܂.",CR,LF,BELL,EOF
msg_USA DB  "CgobN@\ڋ@̏ꍇ, cache L^ɂvOł.",CR,LF
        DB  "IvV̎wFWrite back cache @\Lɂ    WB  on, ܂ -on",CR,LF
        DB  "@@@@@@@@FWrite back cache @\𖳌ɂ    WB  off,       -off",CR,LF
        DB  "@@@@@@@@FԂ₢킹        IvVȂ",CR,LF,CR,LF
msg_MAC DB  "̃vO L̋@ňӖ܂.",CR,LF
        DB  "PC-9801 BX3,BA3,BX4,  PC-9821 Xe,Xs,Xp,Xn, As3,Ap3, Cx,Cb.",CR,LF,EOF

msg_SUBJ        DB  "Write back cache ",EOF
msg_DONE        DB  "ɂ܂.",CR,LF,BELL,EOF
msg_ON          DB  "Li𐳂sj",EOF
msg_OFF         DB  "i䂵Ȃj",EOF
msg_STAT        DB  " Write back cache  ",EOF
msg_IS          DB  "ƂȂĂ܂.",CR,LF,BELL,EOF

data	ends

	end	start


